EXTATTR_COPY_FILE(3) | Library Functions Manual | EXTATTR_COPY_FILE(3)

# NAME

`extattr_copy_file`, `extattr_copy_fd`, `extattr_copy_link`, `cpxattr`, `fcpxattr`, `lcpxattr` —
copy extended attributes from a file to another one

# LIBRARY

Standard C Library (libc, -lc)

# SYNOPSIS

`#include <sys/extattr.h>`

int
`extattr_copy_file`(const char *from, const char *to, int namespace);

int
`extattr_copy_fd`(int from_fd, int to_fd, int namespace);

int
`extattr_copy_link`(const char *from, const char *to, int namespace);

int
`cpxattr`(const char *from, const char *to);

int
`fcpxattr`(int from_fd, int to_fd);

int
`lcpxattr`(const char *from, const char *to);

# DESCRIPTION

`extattr_copy_file`() copies extended attributes of namespace namespace from a file to another one. `extattr_copy_fd`() does the same using open file descriptors, and `extattr_copy_link`() does the same as `extattr_copy_file`() but operates on symbolic links themselves instead of their targets.

`cpxattr`(), `fcpxattr`(), and `lcpxattr`() respectively work the same was as `extattr_copy_file`(), `extattr_copy_fd`(), and `extattr_copy_link`(), but will copy extended attributes from all namespaces accessible to the user, silently skiping unaccessible namespaces.

Please note that none of the extended attribute copying functions are atomic.

# RETURN VALUES

If any of the calls are unsuccessful, the value -1 is returned and the global variable errno is set to indicate the error.

# ERRORS

Extended attribute copying functions may raise errors produced by extattr_list_file(2) and extattr_get_file(2).

# SEE ALSO

getextattr(1), extattr_get_file(2), extattr_namespace_to_string(3), extattr(9)

# HISTORY

Extended attribute support was developed as part of the TrustedBSD Project, and introduced in FreeBSD 5.0 and NetBSD 3.0. It was developed to support security extensions requiring additional labels to be associated with each file or directory.

December 16, 2011 | NetBSD 9.5